//ddr.c

#include "combo.h"

#define begin {
#define end   }


//====================================  
//draws an inductor to the screen based on the coordinates of the upper left hand corner   
void video_ind(char x, char y, char c)
begin
	video_pt(x+6, y+3, c);
	video_pt(x+6, y+4, c);
	video_pt(x+6, y+5, c);
	video_pt(x+6, y+6, c);
	video_pt(x+6, y+8, c);
	video_pt(x+6, y+9, c);
	video_pt(x+6, y+10, c);
	video_pt(x+6, y+11, c);
	video_pt(x+6, y+13, c);
	video_pt(x+6, y+14, c);
	video_pt(x+6, y+15, c);
	video_pt(x+6, y+16, c);
	video_pt(x+6, y+18, c);
	video_pt(x+6, y+19, c);
	video_pt(x+6, y+20, c);
	video_pt(x+6, y+21, c);

	video_pt(x+5, y+2, c);
	video_pt(x+5, y+3, c);
	video_pt(x+5, y+6, c);
	video_pt(x+5, y+7, c);
	video_pt(x+5, y+8, c);
	video_pt(x+5, y+11, c);
	video_pt(x+5, y+12, c);
	video_pt(x+5, y+13, c);
	video_pt(x+5, y+16, c);
	video_pt(x+5, y+17, c);
	video_pt(x+5, y+18, c);
	video_pt(x+5, y+21, c);
	video_pt(x+5, y+22, c);

	video_pt(x+4, y+2, c);
	video_pt(x+4, y+7, c);
	video_pt(x+4, y+12, c);
	video_pt(x+4, y+17, c);
	video_pt(x+4, y+22, c);
	           
	video_pt(x+3, y, c);
	video_pt(x+3, y+1, c);
	video_pt(x+3, y+2, c);
	video_pt(x+3, y+6, c);
	video_pt(x+3, y+7, c);
	video_pt(x+3, y+8, c);
	video_pt(x+3, y+11, c);
	video_pt(x+3, y+12, c);
	video_pt(x+3, y+13, c);
	video_pt(x+3, y+16, c);
	video_pt(x+3, y+17, c);
	video_pt(x+3, y+18, c);
	video_pt(x+3, y+22, c);
	video_pt(x+3, y+23, c);
	video_pt(x+3, y+24, c);
	video_pt(x+3, y+25, c);
	
	video_pt(x+2, y+6, c);
	video_pt(x+2, y+8, c);
	video_pt(x+2, y+11, c);
	video_pt(x+2, y+13, c);
	video_pt(x+2, y+16, c);
	video_pt(x+2, y+18, c);
	
	video_pt(x+1, y+6, c);
	video_pt(x+1, y+8, c);
	video_pt(x+1, y+11, c);
	video_pt(x+1, y+13, c);
	video_pt(x+1, y+16, c);
	video_pt(x+1, y+18, c);
	
	video_pt(x, y+7, c);
	video_pt(x, y+12, c);
	video_pt(x, y+17, c);	
end

//====================================
//draws a resistor to the screen based on the coordinates of the upper left hand corner  
void video_res(char x, char y, char c)
begin         
	video_pt(x+3, y, c);
	video_pt(x+3, y+1, c);
	video_pt(x+3, y+2, c);
	video_pt(x+2, y+3, c);
	video_pt(x+1, y+4, c);
	video_pt(x, y+5, c);
	video_pt(x+1, y+6, c);
	video_pt(x+2, y+7, c);
	video_pt(x+3, y+8, c);
	video_pt(x+4, y+9, c);
	video_pt(x+5, y+10, c);
	video_pt(x+6, y+11, c);
	video_pt(x+5, y+12, c);
	video_pt(x+4, y+13, c);
	video_pt(x+3, y+14, c);
	video_pt(x+2, y+15, c);
	video_pt(x+1, y+16, c);
	video_pt(x, y+17, c);
	video_pt(x+1, y+18, c);
	video_pt(x+2, y+19, c);        
	video_pt(x+3, y+20, c);
	video_pt(x+4, y+21, c);
	video_pt(x+5, y+22, c);
	video_pt(x+6, y+23, c);
	video_pt(x+5, y+24, c);
	video_pt(x+4, y+25, c);
	video_pt(x+3, y+26, c);
	video_pt(x+3, y+27, c);
	video_pt(x+3, y+28, c);        
end                         


//======================================
//draws a capacitor to the screen based on the coordinates of the upper left hand corner  
void video_cap(char x, char y, char c)
begin 
	video_pt(x, y+2, c);
	video_pt(x, y+3, c);
	video_pt(x, y+6, c);
	video_pt(x, y+7, c);

	video_pt(x+1, y+2, c);
	video_pt(x+1, y+3, c);
	video_pt(x+1, y+6, c);
	video_pt(x+1, y+7, c);
     
	video_pt(x+2, y+2, c);
	video_pt(x+2, y+3, c);
	video_pt(x+2, y+6, c);
	video_pt(x+2, y+7, c);

	video_pt(x+3, y, c);
	video_pt(x+3, y+1, c);	
	video_pt(x+3, y+2, c);
	video_pt(x+3, y+3, c);
	video_pt(x+3, y+6, c);
	video_pt(x+3, y+7, c);
	video_pt(x+3, y+8, c);
	video_pt(x+3, y+9, c);
	
	video_pt(x+4, y+2, c);
	video_pt(x+4, y+3, c);
	video_pt(x+4, y+6, c);
	video_pt(x+4, y+7, c);
	
	video_pt(x+5, y+2, c);
	video_pt(x+5, y+3, c);
	video_pt(x+5, y+6, c);
	video_pt(x+5, y+7, c);
	
	video_pt(x+6, y+2, c);
	video_pt(x+6, y+3, c);
	video_pt(x+6, y+6, c);
	video_pt(x+6, y+7, c);
end

//=========================================== 
// draws a box around the capacitor
// should be placed -3,-3 difference from capacitor x,y
//===========================================
void cap_box(char x, char y, char c)
begin
   	video_pt(x,y+4,c);
   	video_pt(x,y+5,c);
     video_pt(x,y+6,c);
   	video_pt(x,y+7,c);
   	video_pt(x,y+8,c);
     video_pt(x,y+9,c);
    	video_pt(x,y+10,c);
     video_pt(x,y+11,c);
     
     video_pt(x+1,y+3,c);
     video_pt(x+1,y+12,c);

     video_pt(x+2,y+2,c);
     video_pt(x+2,y+13,c);
     video_pt(x+3,y+2,c);
     video_pt(x+3,y+13,c);
     
     video_pt(x+4,y+1,c);
     video_pt(x+4,y+14,c);

     video_pt(x+5,y,c);
     video_pt(x+5,y+15,c);
     video_pt(x+6,y,c);
     video_pt(x+6,y+15,c);
     video_pt(x+7,y,c);
     video_pt(x+7,y+15,c);

     video_pt(x+8,y+1,c);
     video_pt(x+8,y+14,c);

     video_pt(x+9,y+2,c);
     video_pt(x+9,y+13,c);
     video_pt(x+9,y+2,c);
     video_pt(x+9,y+13,c);
     video_pt(x+9,y+12,c);
     video_pt(x+9,y+13,c);
     
     video_pt(x+10,y+3,c);
     video_pt(x+10,y+12,c);  
     
    	video_pt(x+11,y+4,c);
   	video_pt(x+11,y+5,c);
     video_pt(x+11,y+6,c);
   	video_pt(x+11,y+7,c);
   	video_pt(x+11,y+8,c);
     video_pt(x+11,y+9,c);
    	video_pt(x+11,y+10,c);
     video_pt(x+11,y+11,c);
end
 
//============================================== 
// draws a box around the inductor
// should be placed -2,-2 difference from inductor x,y
//==============================================
void ind_box(char x, char y, char c)
begin
   	video_pt(x+10,y+6,c);
   	video_pt(x+10,y+7,c);
   	video_pt(x+10,y+8,c);
   	video_pt(x+10,y+9,c);
   	video_pt(x+10,y+10,c);
   	video_pt(x+10,y+11,c);
   	video_pt(x+10,y+12,c);
   	video_pt(x+10,y+13,c);
   	video_pt(x+10,y+14,c);
   	video_pt(x+10,y+15,c);
   	video_pt(x+10,y+16,c);
   	video_pt(x+10,y+17,c);
   	video_pt(x+10,y+18,c);
   	video_pt(x+10,y+19,c);
   	video_pt(x+10,y+20,c);
   	video_pt(x+10,y+21,c);
   	video_pt(x+10,y+22,c);
   	video_pt(x+10,y+23,c);
   	video_pt(x+10,y+24,c);
   	
   	video_pt(x+9,y+5,c);
   	video_pt(x+9,y+25,c);
   	
   	video_pt(x+8,y+3,c);
   	video_pt(x+8,y+4,c);
   	video_pt(x+8,y+26,c);
   	video_pt(x+8,y+27,c);
   	
   	video_pt(x+7,y+1,c);
   	video_pt(x+7,y+2,c);
    	video_pt(x+7,y+28,c);
   	video_pt(x+7,y+29,c);
	                   
	video_pt(x+6,y,c);
    	video_pt(x+6,y+30,c);  
	video_pt(x+5,y,c);
	video_pt(x+5,y+30,c);
	
	video_pt(x+4,y,c);
	video_pt(x+4,y+30,c);
	video_pt(x+4,y,c);
	video_pt(x+4,y+30,c);
	
	video_pt(x+3,y,c);
	video_pt(x+3,y+30,c);
	           
	video_pt(x+2,y+1,c);
	video_pt(x+2,y+2,c);
 	video_pt(x+2,y+3,c);
	video_pt(x+2,y+4,c);
	video_pt(x+2,y+5,c);
	video_pt(x+2,y+6,c);
	video_pt(x+2,y+24,c);
	video_pt(x+2,y+25,c);
	video_pt(x+2,y+26,c);
	video_pt(x+2,y+27,c);
	video_pt(x+2,y+28,c);
	video_pt(x+2,y+29,c);
	
	video_pt(x+2,y+7,c);
	video_pt(x+2,y+23,c);

	video_pt(x+1,y+8,c);
	video_pt(x+1,y+22,c);
	
	video_pt(x,y+9,c);
	video_pt(x,y+10,c);
	video_pt(x,y+11,c);
	video_pt(x,y+12,c);
	video_pt(x,y+13,c);
	video_pt(x,y+14,c);
	video_pt(x,y+15,c);
	video_pt(x,y+16,c);
	video_pt(x,y+17,c);
	video_pt(x,y+18,c);
	video_pt(x,y+19,c);
	video_pt(x,y+20,c);
	video_pt(x,y+21,c);
end

//===================================================
// draws a box around the resistor
// should be placed -3,-3 difference from resistor x,y
//===================================================
void res_box(char x, char y, char c)
begin
     video_pt(x+5,y,c);
     video_pt(x+6,y,c);
     video_pt(x+7,y,c);
     
     video_pt(x+4,y+1,c);
     video_pt(x+8,y+1,c);       
     video_pt(x+4,y+2,c);
     video_pt(x+8,y+2,c);
     
     video_pt(x+3,y+3,c);
     video_pt(x+9,y+3,c);      
     video_pt(x+3,y+4,c);
     video_pt(x+9,y+4,c);                     
     video_pt(x+3,y+5,c);
     video_pt(x+9,y+5,c);       
               
     video_pt(x+2,y+6,c);
     video_pt(x+8,y+6,c);      
     video_pt(x+1,y+7,c);
     video_pt(x+7,y+7,c);      
     video_pt(x,y+8,c);
     video_pt(x+6,y+8,c);
     
     video_pt(x+1,y+9,c);
     video_pt(x+7,y+9,c);       
     video_pt(x+2,y+10,c);
     video_pt(x+8,y+10,c);      
     video_pt(x+3,y+11,c);
     video_pt(x+9,y+11,c);      
     video_pt(x+4,y+12,c);
     video_pt(x+10,y+12,c);     
     video_pt(x+5,y+13,c);
     video_pt(x+11,y+13,c);      
     video_pt(x+6,y+14,c);
     video_pt(x+12,y+14,c);
         
     video_pt(x+5,y+15,c);
     video_pt(x+11,y+15,c);        
     video_pt(x+4,y+16,c);
     video_pt(x+10,y+16,c);      
     video_pt(x+3,y+17,c);
     video_pt(x+9,y+17,c);      
     video_pt(x+2,y+18,c);
     video_pt(x+8,y+18,c);      
     video_pt(x+1,y+19,c);
     video_pt(x+7,y+19,c);      
     video_pt(x,y+20,c);
     video_pt(x+6,y+20,c);
     
     video_pt(x+1,y+21,c);
     video_pt(x+7,y+21,c);       
     video_pt(x+2,y+22,c);
     video_pt(x+8,y+22,c);       
     video_pt(x+3,y+23,c);
     video_pt(x+9,y+23,c);       
     video_pt(x+4,y+24,c);
     video_pt(x+10,y+24,c);      
     video_pt(x+5,y+25,c);
     video_pt(x+11,y+25,c);      
     video_pt(x+6,y+26,c);
     video_pt(x+12,y+26,c);       
     video_pt(x+5,y+27,c);
     video_pt(x+11,y+27,c);       
     video_pt(x+4,y+28,c);
     video_pt(x+10,y+28,c);       
	video_pt(x+3,y+29,c);
     video_pt(x+9,y+29,c);       
     video_pt(x+3,y+30,c);
     video_pt(x+9,y+30,c);      
     video_pt(x+3,y+31,c);
     video_pt(x+9,y+31,c);       
     video_pt(x+4,y+32,c);
     video_pt(x+8,y+32,c);       
     video_pt(x+4,y+33,c);
     video_pt(x+8,y+33,c);   
         
     video_pt(x+5,y+34,c);
     video_pt(x+7,y+34,c);
     video_pt(x+6,y+34,c);
end

//=================================
//Places the directions for ddr on the screen using 5 different drawing frames
//to avoid timing issues, requires a start button press to continue on with the game
//=================================
void DDRDir(void)
begin  
	switch(drawingFrame)
	begin
		case(0):
		begin
		     sprintf(screenString,"TASK 3:");
		     video_putsmalls(4,15,screenString);
		     
		     sprintf(screenString,"ENGINEERING CORE CLASSES");
		     video_putsmalls(4,25,screenString);
		     
		     sprintf(screenString,"STAY IN SYNC WITH");
		     video_putsmalls(4,40,screenString); 
		     
		     
		     
		     drawingFrame=1;
			break;
		end
		case(1):
		begin

			sprintf(screenString,"DR DAVE WRITECHAMPS");
		     video_putsmalls(4,48,screenString);
		     
		     sprintf(screenString,"PRESS A FOR INDUCTOR");
		     video_putsmalls(4,63,screenString); 
		     
		     sprintf(screenString,"PRESS B FOR RESISTOR");
		     video_putsmalls(4,71,screenString);
		     
			
		
			drawingFrame=2;
			break;
		end
		case(2):
		begin
		
			sprintf(screenString,"PRESS C FOR CAPACITOR");
		     video_putsmalls(4,79,screenString); 
    		   	video_line(101,50,101,70,1);   
    		   	video_cap(98,55,1);
		     drawingFrame = 3;
		   	
		end
		case(3):
		begin    
			if(button==startButton)
			begin
				video_putsmalls(4,15,blanks);
     		     video_putsmalls(4,25,longBlanks);
     		     video_putsmalls(4,40,longBlanks);
     		     
     		     
            		button=0;
				drawingFrame = 4;
			end
			break;
		end
		case(4):
		begin  
			video_putsmalls(4,48,longBlanks);
     	     video_putsmalls(4,63,longBlanks); 
     	     video_putsmalls(4,71,longBlanks);  
               
          	drawingFrame=5;
          	break;
		end   
		case(5):
		begin 
			video_putsmalls(4,79,longBlanks);  
        	     video_cap(98,55,0);
          	levelState = Init;
          	drawingFrame=0;
          	break;
		end
	end
end

//==================================
//initializes song values for davy and animation references for the circuit components
//and prints the level title on to the screen
//==================================
void DDRInit(void)
begin
	switch(drawingFrame)
	begin
 		case(0):
 		begin
 			sprintf(screenTitle,"Dave");
            	drawingFrame=1;
            	break;
    		end
    		case(1):
    		begin
    			video_puts(12,3,screenTitle);
    			drawingFrame=2;
    			break;
    		end
    		case(2):
    		begin
    		   	sprintf(screenTitle,"Writechamps");
    		   	drawingFrame=3;
    		   	break;
    		end
    		case(3):
    		begin
    		   	video_puts(42,3,screenTitle);
    		   	drawingFrame=4;
    		   	break;
    		end
    		case(4):
    		begin
                 //init animation
                 vx=2;
                 
                 video_line(101,12,101,88,1);
                 
                 holdCap=0;
                 holdRes=0;
                 holdInd=0;
                 capY = 15;
                 indY = 27;
                 resY = 54;
                 levelState=Game;
                 holdCountReset=30; 
                 
                 songState=davy;
		           noteIndex=1;  
		       	  noteLength=0;    
		           count=0;
		           DDRcount = 0;
                 //songState = none;
                 drawingFrame=0;
                 break;
          end
          
      end
end


//==================================
//the start input determines where on the screen the x coordinate should begin
//(usually this number is 2), index determines what value of DDRcount the capacitor
//should begin to move
//==================================

void animateCAP(unsigned char start, unsigned char index)
begin
	if (DDRcount ==  index) video_cap(start,capY,1);        
 	else if((index < DDRcount) && (DDRcount < (index+108-start)))
     	begin   
     		video_cap((start+DDRcount-vx-index),capY,0);   
        	video_cap((start+DDRcount-index),capY,1);              
     	end 
	switch(DDRcount-index+start)
	begin
		case(98):
		begin
		     	capTime=1; //if the capacitor is at the edge of the board, 
		     	break;	   //it will check for a button press to give the player credits
		end
		case(108):
		begin
			video_cap((start+DDRcount-vx-index),capY,0);
		     	break;
		end

		
	end
end 

//==================================
//the start input determines where on the screen the x coordinate should begin
//(usually this number is 2), index determines what value of DDRcount the resistor
//should begin to move
//==================================
void animateRES(unsigned char start, unsigned char index)
begin    
	if (DDRcount ==  index) video_res(start,resY,1);        
 	else if((index < DDRcount) && (DDRcount < (index+108-start)))
     begin
     	video_res((start+DDRcount-vx-index),resY,0);   
          video_res((start+DDRcount-index),resY,1);             
     end 
	switch(DDRcount-index+start)
	begin
		case(98):
		begin
		     resTime=1;	//if the resistor is at the edge of the board,
		     break;	//it will check for a button press to give the player credits
		end
		case(108):
		begin
			video_res((start+DDRcount-vx-index),resY,0);
		     break;
		end

		
	end
end


//==================================
//the start input determines where on the screen the x coordinate should begin
//(usually this number is 2), index determines what value of DDRcount the inductor
//should begin to move
//==================================
void animateIND(unsigned char start, unsigned char index)
begin	
	if (DDRcount ==  index) video_ind(start,indY,1);        
 	else if((index < DDRcount) && (DDRcount < (index+108-start)))
     begin
     	video_ind((start+DDRcount-vx-index),indY,0);   
          video_ind((start+DDRcount-index),indY,1);          
     end
	switch(DDRcount-index+start)
	begin
		case(98):
		begin
		     indTime=1;	//if the inductor is at the edge of the board,
		     break;	//it will check for a button press to give the player credits
		end
		case(108):
		begin
			video_ind((start+DDRcount-vx-index),indY,0);
		     break;
		end

		
	end
end


//==================================
//checks for a button press and if the correct component is lined up at the edge of the 
//board, credits will be awarded
//==================================
void checkHit(void)
begin       
   	switch(button)
	   begin
			case(AButton):
	  		begin
				if (indTime)
		  		begin
        			ind_box(96,indY-2,1);   //draw box around inductor to let user know that they got it right!   
        			credits=credits+2;
        			holdInd=4; 
   		   end 			
		  	break;
		end
		case(BButton):
		begin
		     if(resTime)
           begin
           		res_box(95,resY-3,1);		//draw box around resistor to let user know that they got it right!  
         		credits=credits+2;   		
        			holdRes=4;  
        	  end  
			break;
		end
		case(CButton):
		begin  
			if(capTime)
   		begin
     		   	cap_box(95,capY-3,1);		//draw box around capacitor to let user know that they got it right!  
     		   	credits=credits+2;
     		   	holdCap=4;     
     		end
			break;
		end
	
		default: break;
	end      
	if(holdCap>1) holdCap--;
     else if(holdCap == 1) 
     begin
     	holdCap=0;
     	cap_box(95,capY-3,0);           
     end
     if(holdInd>1) holdInd--;
     else if(holdInd == 1)
     begin
     	holdInd=0;
     	ind_box(96,indY-2,0);  
     end
     if(holdRes>1) holdRes--;
     else if(holdRes == 1)
     begin
     	res_box(95,resY-3,0);  
     	holdRes=0;
 	  end
     indTime=0;
     capTime=0;
     resTime=0;   
  
	button=0;
end 

//==================================
//This function controls the davy round of ddr
//setting up when and where the pieces will start
//==================================
void DDR(void)
begin   
	switch(drawingFrame)
	begin
 		case(0):
 		begin    
 			video_line(101,12,101,88,1); //redraws line so that it wont "erase" when animated over
			animateIND(62,0);
 	 		animateCAP(42,0);
    			animateRES(28,0);    
    	 		animateCAP(14,0);
 	 		animateRES(2,16);
 	 		animateCAP(2,20);
 	 		animateRES(2,32);
 	 		animateIND(2,46);
 			drawingFrame=1;
           break;
    		end
    		case(1):
    		begin
        	  	if (DDRcount > 155) // if DDRcount is greater than 155 hte song has ended so head to next part of statemachine
        	  	begin
        	  		levelState = TimesUp; 
        			drawingFrame=0;    
        			video_line(101,12,101,88,0);
      		end
       		DDRcount=count;///2; 	
        	  	
    			checkHit();
    			sprintf(screenString,"%03d",credits);
			video_putsmalls(4,92,screenString);    
    			drawingFrame=0;
    			break;
    		end    		      
      end  
end

//==================================
//this function reminds user of the instructions
//and initializes the song playing constants for MYOC
//also it changes the y values of the circuit components for a "board switch"
//==================================
void switchboards(void)
begin  
     switch(drawingFrame)
	begin
		case(0):
		begin
		     sprintf(screenString,"ROUND 2");
		     video_putsmalls(4,15,screenString);
		     
		     //sprintf(screenString,"ENGINEERING CORE CLASSES");
		     //video_putsmalls(4,25,screenString);
		     
		     sprintf(screenString,"WATCH OUT FOR THE BOARD SWITCH");
		     video_putsmalls(4,40,screenString); 
		     
		     drawingFrame=1;
			break;
		end
		case(1):
		begin		     
		     sprintf(screenString,"PRESS A FOR INDUCTOR");
		     video_putsmalls(4,63,screenString); 
		     
		     sprintf(screenString,"PRESS B FOR RESISTOR");
		     video_putsmalls(4,71,screenString);  
		
		     drawingFrame=2;
		     break;
		end
		case(2):
		begin
		     sprintf(screenString,"PRESS C FOR CAPACITOR");
		     video_putsmalls(4,79,screenString); 
    		     video_line(101,50,101,70,1);   
    		     video_cap(98,55,1);
		     drawingFrame = 3;
		   	
		end
		case(3):
		begin    
		     if(button==startButton)
		     begin
		     	video_putsmalls(4,15,blanks);
     		     	video_putsmalls(4,40,longBlanks);
     		     	button=0;
        	     	drawingFrame = 4;
		     end
		     break;
		end
		case(4):
		begin  
		     video_putsmalls(4,63,longBlanks); 
	     	     video_putsmalls(4,71,longBlanks);  
          	     drawingFrame=5;
          	     break;
		end   
		case(5):
		begin 
		     video_putsmalls(4,79,longBlanks);  
        	     video_cap(98,55,0); 
        	     holdCap=0;
                     holdRes=0;
                     holdInd=0;            
        	     capY=74;
        	     indY=15;
        	     resY=42;      
        	     songState=MYOC;
		     noteIndex=1;  
		     noteLength=0;    
		     count=0;
		     DDRcount=0;
          	     levelState = Check;
          	     drawingFrame=0;
          	     break;
	        end//case(5)
	end//switch
end//switchboards

//====================================
void DDRStateMachine(void)
begin
	switch(levelState)
	begin
		case(Dir):
		begin
			DDRDir();
			break;
		end 
		case(Init):
		begin
			DDRInit(); 
			break;
		end
		case(Game): //play round 1
		begin
			DDR(); 
			break;
		end
		case(TimesUp): //initialize round 2
		begin       
			
         		switchboards(); 
			break;
		end
		case(Check): //play round 2
		begin
		
  			switch(drawingFrame)
    			begin
 				case(0):
 				begin    
 		    			video_line(101,12,101,88,1);
					animateIND(62,0);  
 	 				animateCAP(42,0); 
    	 				animateRES(28,0); 
    	 				animateCAP(14,0);      
           	 			animateRES(2,16);
           	 			animateCAP(2,20);   
           	 			animateRES(2,36);
           	 			animateIND(2,46); 
                  			drawingFrame=1;
                  			break;
            			end
            			case(1):
           			begin     
              				DDRcount=count;  //count is updated in main loop while the song is played (whenever a note changes it increases by 2)
                 			if (DDRcount > 162) 
                  			begin
                  				levelState = ShowCredits; 
                  				drawingFrame=0;    
            				end
              				checkHit();
              				sprintf(screenString,"%03d",credits);
              				video_putsmalls(4,92,screenString);    
              				drawingFrame=0;
              				break; 
 				end //case(1)   		      
     			end //switch(drawingFrame)             
			break;
		end //case(Check)
		case(ShowCredits): //clear titles and line from junior year and initialize for transition stage
		begin  
			switch(drawingFrame)
			begin
				case(0):
 	    			begin
 					sprintf(screenTitle,"    ");
              				drawingFrame=1;
              				break;
    	    			end
    	    			case(1):
    	    			begin
    	    				video_puts(12,3,screenTitle);
    					drawingFrame=2;
    					break;
    	 			end
    	  			case(2):
    	  			begin
    		   			sprintf(screenTitle,"           ");
    		   			drawingFrame=3;
		    		   	break;
		    		end
		    		case(3):
		    		begin
		    		   	video_puts(42,3,screenTitle);
		    		   	drawingFrame=4;
		    		   	break;
		    		end  
		    		case(4):
		    		begin          
			    		video_line(101,12,101,88,0);
                  			levelState=Dir; 
                  			songState = none;
                  			yearState=trans;
		    		   	drawingFrame=0;
		    		   	break;
		    		end//case(4)
		     	end//switch(drawingFrame)
			break;
		end//case(showCredits)
		default: break;
	end//switch(levelState)
end//DDRStateMachine